1000 REMark ***** Fast Copy Used Sectors Only *****
1010 :
1020 REMark          EX FAST_COPY_SECTOR_EXE or
1030 REMark          EX FAST_COPY_SECTOR_EXE;'1' (or '2')
1040 :
1050 REPeat main
1060   init
1070   copy_used_sectors
1080   REPeat ask
1090     INPUT 'Any more discs to copy (y/n) ';ok$
1100     IF ok$ = '' THEN ok$ = 'x'
1110     REPeat check
1120       IF ok$ INSTR 'yn' = 0
1130          NEXT ask
1140       ELSE 
1150          EXIT ask
1160       END IF 
1170     END REPeat check
1180   END REPeat ask
1190   IF ok$ == 'n'
1200      PRINT 'Fast Copy Sector Finished.'
1210      EXIT main
1220   END IF 
1230 END REPeat main
1240 :
1250 :
1260 DEFine PROCedure init
1270   IMPLICIT% x1, x2, alloc_block, sec
1280   DIM sector$(512), map$(1440), info$(96)
1290   DIM logical_physical$(18), dest_dev$(5), source_dev$(5)
1295   DIM ok$(1)
1300   in% = 3
1310   out% = 4
1320   get_drives
1330   read_map
1340   track_offset% = get_a_word%(info$(39 TO 40))
1350   sectors_per_track% = get_a_word%(info$(27 TO 28))
1360   blocks_per_track% = get_a_word%(info$(29 TO 30)) / 3
1370   logical_physical$ = info$(41 TO 58)
1380 END DEFine init
1390 :
1400 :
1410 DEFine PROCedure get_drives
1420   LOCal dv$(1), loop
1430   title
1440   dv$ = OPTION_CMD$
1450   REPeat loop
1460     IF dv$ = '' OR dv$ < '1' OR dv$ > '2'
1470        INPUT 'Which drive will be used for SOURCE files (1/2) ';dv$
1480     END IF 
1490     IF (dv$ INSTR '12') AND (dv$ <> '') THEN EXIT loop
1500   END REPeat loop
1510   source_dev$ = 'flp' & dv$ & '_'
1520   IF dv$ = '1'
1530      dest_dev$ = 'flp2_'
1540   ELSE 
1550      dest_dev$ = 'flp1_'
1560   END IF 
1570   INPUT 'Place SOURCE disc in ' & source_dev$ & ' & press ENTER';dv$
1580   INPUT 'Place DEST disc in ' & dest_dev$ & ' & press ENTER';dv$
1590 END DEFine get_drives
1600 :
1610 :
1620 DEFine PROCedure read_map
1630   LOCal next_map%, pointer%
1640   title
1650   OPEN #in%, source_dev$ & '*d2d'
1660   OPEN #out%, dest_dev$ & '*d2d'
1670   AT 3,0: PRINT 'Reading map sector 1'
1680   SET_POSITION #in%, 1
1690   sector$ = INPUT$(#in%, 512)
1700   AT 3,0: PRINT 'Writ'
1710   PUT #out% \1, sector$
1720   info$ = sector$(1 TO 96)
1730   map$(1 TO 416) = sector$(97 TO 512)
1740   FOR x1 = 0 TO 1
1750     next_map% = CODE(info$(x1 + 42)) + 1
1760     AT 3, 0: PRINT 'Read'
1770     AT 3, 19: PRINT x1 + 2
1780     SET_POSITION #in%, next_map%
1790     sector$ = INPUT$(#in%, 512)
1800     AT 3, 0: PRINT 'Writ'
1810     PUT #out% \next_map%, sector$
1820     pointer% = 512 * x1 + 417
1830     map$(pointer% TO (pointer% + 511)) = sector$
1840   END FOR x1
1850   :
1860   REMark *** dest disc is now corrupted by source discs map ***
1870   :
1880 END DEFine read_map
1890 :
1900 :
1910 DEFine FuNction get_a_word%(text$)
1920   RETurn CODE(text$(1)) *256 + CODE(text$(2))
1930 END DEFine get_a_word%
1940 :
1950 :
1960 DEFine PROCedure title
1970   CLS
1980   CSIZE 0,1
1990   PRINT 'Fast Sector Copier'
2000   CSIZE 0,0
2010   PRINT
2020 END DEFine title
2030 :
2040 :
2050 DEFine PROCedure copy_used_sectors
2060   LOCal do_it%, time, offset
2070   LOCal track%, side%, sector%(3)
2080   title
2090   AT 3,0: PRINT 'Testing allocation block'
2100   time = DATE
2110   FOR alloc_block = 1 TO 479
2120     AT 3, 0: PRINT 'Test'
2130     AT 3, 25: PRINT alloc_block
2140     do_it% = block_used% (alloc_block)
2150     IF do_it% = 1
2160        FOR sec = 1 TO 3
2170          AT 3,0: PRINT 'Copy'
2180          offset = sector%(sec) + (side% * 256) + (track% * 65536) + 1
2190          SET_POSITION #in%, offset
2200          sector$ = INPUT$(#in%, 512)
2210          PUT #out% \offset, sector$
2220        END FOR sec
2230     END IF 
2240     IF do_it% = -1
2250        PRINT 'Error.'
2260        PRINT 'Allocation block = ' & alloc_block
2270        PRINT 'Track            = ' & track%
2280        PRINT 'side             = ' & side%
2290        PRINT 'Sectors          = ';
2300        FOR sec = 1 TO 3
2310          PRINT sector%(sec) & ' ';
2320        END FOR sec
2330        PRINT
2340        sec = -1
2350        EXIT alloc_block
2360     END IF 
2370   END FOR alloc_block
2380   CLOSE #in%
2390   CLOSE #out%
2400   IF sec < 0 THEN RETurn 
2410   time = DATE - time
2420   PRINT 'Disc copied in ' & (time DIV 60) & ' minutes and ';
2430   PRINT (time MOD 60) & ' seconds.'
2440 END DEFine copy_used_sectors
2450 :
2460 :
2470 DEFine FuNction block_used%(unit)
2480   LOCal start, value, file$(6), disc_block%, logical$(3)
2490   LOCal log_offset%
2500   IF unit < 0 OR unit > 479
2510      PRINT 'Allocation block out of range 0 - 479 (' & unit & ')'
2520      RETurn -1
2530   END IF 
2540   track% = unit DIV blocks_per_track%
2550   disc_block% = unit MOD blocks_per_track%
2560   log_offset% = (disc_block% * 3) + 1
2570   logical$ = logical_physical$(log_offset% TO (log_offset% + 2))
2580   value = 0
2590   start = 3 * unit
2600   FOR x2 = 1 TO 3
2610     value = value * 256 + CODE(map$(start + x2))
2620   END FOR x2
2630   file$ = HEX$(value, 24)
2640   IF (file$(1 TO 2) == 'FC') OR (file$(1 TO 2) == 'FD') OR (file$(1 TO 2) == 'FE') OR (file$(1 TO 2) == 'FF')
2650      RETurn 0
2660   END IF 
2670   :
2680   REMark ** FC = pending deletion     **
2690   REMark ** FD = unused block         **
2700   REMark ** FE = bad block            **
2710   REMark ** FF = block does not exist **
2720   :
2730   IF CODE(logical$(1)) >= 128
2740      side% = 1
2750      FOR x2 = 1 TO 3
2760        sector%(x2) = CODE(logical$(x2)) - 128
2770      END FOR x2
2780   ELSE 
2790      side% = 0
2800      FOR x2 = 1 TO 3
2810        sector%(x2) = CODE(logical$(x2))
2820      END FOR x2
2830   END IF 
2840   :
2850   REMark ** Convert to actual sector withing cylinder, to  **
2860   REMark ** allow for delay between stepping to next track **
2870   :
2880   FOR x2 = 1 TO 3
2890     sector%(x2) = (sector%(x2) + (track% * track_offset%)) MOD sectors_per_track%
2900   END FOR x2
2910   RETurn 1
2920 END DEFine block_used%
